Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# RecorderController Class Reference

This object manages the process of recording the user's runtime inputs to a bam file so that the session can be recreated later. More...

Inheritance diagram for RecorderController:

List of all members.

## Public Member Functions
| RecorderController ()
| addRecorder (string name, RecorderBase recorder)
| Adds the named recorder to the set of recorders that are in use.
bool | beginPlayback (Filename const filename)
| Begins playing back data from the indicated filename.
bool | beginRecord (Filename const filename)
| Begins recording data to the indicated filename.
| close ()
| Finishes recording data to the indicated filename.
double | getClockOffset ()
| Returns the delta offset between the actual frame time and the frame time written to the log.
Filename const | getFilename ()
| Returns the filename that was passed to the most recent call to begin_record() or begin_playback().
int | getFrameOffset ()
| Returns the delta offset between the actual frame count and the frame count written to the log.
bool | getFrameTie ()
| See set_frame_tie().
int | getRandomSeed ()
| Returns the random seed that was set by a previous call to set_random_seed(), or the number read from the session file after begin_playback() has been called.
RecorderBase | getRecorder (string name)
| Returns the recorder with the indicated name, or NULL if there is no such recorder.
unsigned int | getStartTime ()
| Returns the time (and date) at which the current session was originally recorded (or, in recording mode, the time at which the current session began).
bool | hasRecorder (string name)
| Returns true if the named recorder has been added to the table by a previous call to add_recorder(), false otherwise.
bool | isError ()
| Returns true if the controller has been opened for input or output output and there is an error on the stream, or false if the controller is closed or if there is no problem.
bool | isOpen ()
| Returns true if the controller has been opened for either input or output, false otherwise.
bool | isPlaying ()
| Returns true if the controller has been opened for input, false otherwise.
bool | isRecording ()
| Returns true if the controller has been opened for output, false otherwise.
| playFrame ()
| Gets the next frame of data from all of the active recorders and adds it to the output file.
| recordFrame ()
| Gets the next frame of data from all of the active recorders and adds it to the output file.
bool | removeRecorder (string name)
| Removes the named recorder from the table.
| setFrameTie (bool frame_tie)
| Sets the frame_tie flag.
| setRandomSeed (int random_seed)
| Indicates an arbitrary number to be recorded in the session file as a random seed, should the application wish to take advantage of it.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This object manages the process of recording the user's runtime inputs to a bam file so that the session can be recreated later.

## Constructor & Destructor Documentation

RecorderController | ( |  | ) |

## Member Function Documentation

addRecorder | ( | string | name,
|  | RecorderBase | recorder
| ) |  |

Adds the named recorder to the set of recorders that are in use.

If the controller is in recording mode, the named recorder will begin recording its status to the session file. If the controller is in playback mode and the name and type matches a recorder in the session file, the recorder will begin receiving data.

bool beginPlayback | ( | Filename const | filename | ) |

Begins playing back data from the indicated filename.

All of the recorders in use should already have been added, although this may define additional recorders if they are present in the file (these new recorders will not be used). This may also undefine recorders that were previously added but are not present in the file.

bool beginRecord | ( | Filename const | filename | ) |

Begins recording data to the indicated filename.

All of the recorders in use should already have been added.

close | ( |  | ) |

Finishes recording data to the indicated filename.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

double getClockOffset | ( |  | ) |

Returns the delta offset between the actual frame time and the frame time written to the log.

This is essentially the time at which the recording (or playback) started.

Filename const getFilename | ( |  | ) |

Returns the filename that was passed to the most recent call to begin_record() or begin_playback().

int getFrameOffset | ( |  | ) |

Returns the delta offset between the actual frame count and the frame count written to the log.

This is essentially the frame number at which the recording (or playback) started.

bool getFrameTie | ( |  | ) |

See set_frame_tie().

int getRandomSeed | ( |  | ) |

Returns the random seed that was set by a previous call to set_random_seed(), or the number read from the session file after begin_playback() has been called.

RecorderBase getRecorder | ( | string | name | ) |

Returns the recorder with the indicated name, or NULL if there is no such recorder.

If the controller is in playback mode, this may return the recorder matching the indicated name as read from the session file, even if it was never added to the table by the user. In this case, has_recorder() may return false, but get_recorder() will return a non-NULL value.

unsigned int getStartTime | ( |  | ) |

Returns the time (and date) at which the current session was originally recorded (or, in recording mode, the time at which the current session began).

bool hasRecorder | ( | string | name | ) |

Returns true if the named recorder has been added to the table by a previous call to add_recorder(), false otherwise.

If the controller is in playback mode, this will also return false for a recorder that was found in the session file but was never explicitly added via add_recorder(); see get_recorder().

bool isError | ( |  | ) |

Returns true if the controller has been opened for input or output output and there is an error on the stream, or false if the controller is closed or if there is no problem.

bool isOpen | ( |  | ) |

Returns true if the controller has been opened for either input or output, false otherwise.

bool isPlaying | ( |  | ) |

Returns true if the controller has been opened for input, false otherwise.

bool isRecording | ( |  | ) |

Returns true if the controller has been opened for output, false otherwise.

playFrame | ( |  | ) |

Gets the next frame of data from all of the active recorders and adds it to the output file.

recordFrame | ( |  | ) |

Gets the next frame of data from all of the active recorders and adds it to the output file.

bool removeRecorder | ( | string | name | ) |

Removes the named recorder from the table.

Returns true if successful, false if there was no such recorder.

If the controller is in recording mode, the named recorder will stop recording. If the controller is in playback mode, the named recorder will disassociate itself from the session file (but if the session file still has data for this name, a default recorder will take its place to decode the data from the session file).

setFrameTie | ( | bool | frame_tie | ) |

Sets the frame_tie flag.

When this is true, sessions are played back frame-for-frame, based on the frame count of the recorded session. This gives the most accurate playback, but the playback rate will vary according to the frame rate of the playback machine.

When this is false, sessions are played back at real time, based on the clock of the recorded session. This may introduce playback discrepencies if the frames do not fall at exactly the same times as they did in the original.

setRandomSeed | ( | int | random_seed | ) |

Indicates an arbitrary number to be recorded in the session file as a random seed, should the application wish to take advantage of it.

This must be set before begin_record() is called.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties